/*  
 *  bcrypt.c
 *
 *  Version 2.1 
 *  01 November 1999 
 *
 *   FILE'S CRYPT PROGRAM
 *
 *   Realised by MARTINEZ Sylvain  
 *
 *   Based on the BUGS crypt's algorithm of MARTINEZ Sylvain  
 *   (Big and Usefull Great Security)  
 *
 *   UNIX Administrator (Merrill Lynch, UK) 
 *   Network Security Consultant (ASI, France)
 *   Passion: Cryptology and Network Security  
 *   email: martinez@asi.fr  
 *          sylvain.Martinez@netcourrier.com 
 *   URL: http://www.asi.fr/~martinez
 *
 *  Copyright (C) 1996,1997,1998,1999 MARTINEZ Sylvain  
 *  THIS IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER  
 *  THE TERMS OF THE GNU GENERAL PUBLIC LICENSE, see the file COPYING.  
 */

/*
 * HISTORY
 *
 * --- Version in progress ---
 *
 * --- V 2.1 ---
 *
 * 01/11/1999 : - Minor bug corrected, the verbose mode was not working 
 *		  if you were using "-v" as the last argument.
 *
 * 01/11/1999 : - Something really weird... If the character's length of 
 *		  a filepath is 44 and there is a space in it, strcpy
 *	          seems to copy to many characters, strncpy doesn't work 
 *		  either ! 
 *		  I had to change the way I was initialising the array
 *		  instead of doing malloc(strlen(argv[i+1]) I am doing
 *		  malloc(strlen(argv[i+1]) + 1) 
 *		  After Many tests it seems because strcpy adds /0 at the end 
 *		  why then this is not happening if the length is not 44 ??
 *		  It sounds like a memory handling problem, but I checked
 *		  evreything and did not find any problems...
 *		  If someone have any ideas, let me know ! :O)
 *
 * 31/10/1999 : - Removed a dummy "printf" only used in testing
 *
 * --- V 2.0 ---
 *
 * 24/07/1999 : - Replaced sizeof() by strlen when calling malloc()
 *		- Corrected a problem while overwriting the source file
 *
 * 23/07/1999 : - Added a check in the checkargs()
 *		- Corrected a malloc problem with PARAM_KEYFILE
 *
 * 22/07/1999 : - Corrected errors while crypting with a keyfile
 *		  This was caused by the way I was overwriting files 
 *		- Corrected an error while uncrypting with a keyfile
 *		  This was because I didn't initialised the length var.
 *		  Added: length=varinit->NB_CHAR;
 *
 * 20/07/1999 : - Changed the way I handle parameters, much more efficient 
 *		- You can now overwrite a file you crypt.
 *
 * 09/07/1999 : - Changed pass_clear from char to unsigned char
 *
 * --- V 1.7 ---
 *
 * 16/02/1998 : - Corrected the input password bug
 *		- Changed bcrypt initialisation (binit)
 *
 * --- V 1.6 ---
 *
 * 07/02/1998 : - Added the libcrypt version number
 *
 * --- V 1.5 ---
 *
 * 27/01/1998 : - Added the -f option
 *	        - cleaned the source code, everything is not anymore
 *		  in the main() function !
 *
 * ---- V 1.4 ----
 *
 * 13/01/1998 : - Added globalvar type variable
 *
 * 11/01/1998 : - Added global variable VERSION
 *              - Started to do an HISTORY
 */


/*
 * This header is important
 * There is some global variables that you will need, eg:
 * USER_LENGTH = size of the string that contain the user name
 * other reserved variable name : KEYLENGTH, varinit->NB_CHAR, varinit->NB_INDEX, etc
 * Read the documentation or have a look of this header for more information
 */   
#include "../include/libcrypt.h"
#include "../include/extra.h"

char *VERSION="v2.1, November 1999";


  /*
   * Default : mode = 0 (non verbose)
   *           Key's length = 128 bits
   *	       Power = 0
   *	       Key's file = 0
   */   

     int PARAM_CRYPT=0;
     int PARAM_UNCRYPT=0;
     char *PARAM_SOURCE="";
     char *PARAM_TARGET="";
     char *PARAM_KEYFILE="";
     int PARAM_KEYLENGTH=128;
     int PARAM_POWER=0;
     int PARAM_VERBOSE=0;   
     globalvar *varinit;
     int OPTION;

void usage(void);
int init(void);
int crypt(void);
int argcheck(int, char **);

/*
 * Functions
 */

int main(int argc, char **argv)
{
    
  if (argcheck(argc, argv) == 0) return 0;

  if (init() == 0) return 0;

  if (crypt() == 0) return 0;
 
  return 1;
}


/*
 * Initialised the global variables
 */ 
int init()
{
varinit = (globalvar *) malloc(sizeof(globalvar));
/*
 * The log will be generated in the stderr output
 */ 
binit(PARAM_KEYLENGTH, 0, varinit);
return 1;
}

/*
 * Crypt file function
 */
int crypt()
{
  int i, crypt_time, length;
  char *pass_verif, carac, *tempname="";
  unsigned char *pass_clear;
  int status, RETURN=10;

pass_clear = (unsigned char *) malloc (varinit->NB_CHAR);
pass_verif = (char *) malloc (varinit->NB_CHAR);

for(i=0; i < varinit->NB_CHAR; i++) pass_clear[i]='\0';
  
printf("\n Bcrypt %s, (C) Martinez Sylvain",VERSION);
printf("\n BUGS ALGORITHM CRYPT FILE ");
printf("\n Libcrypt version : '%s'",varinit->LIB_VERSION);
printf("\n\n Crypt file in progress.");
printf("\n KEY'S LENGTH used : %d.",PARAM_KEYLENGTH);
if (1 == PARAM_CRYPT)
   {
    printf("\n Action : CRYPT.");
   if (0 == PARAM_POWER)
       printf("\n Power : (0) Standard algorithm."); 
    else
       printf("\n Power : (1) Probality algorithm.");

    tempname = (char *) malloc(strlen(PARAM_SOURCE)+10);
    strcpy(tempname, PARAM_SOURCE);

    if (0 == strcmp(PARAM_TARGET, PARAM_SOURCE))
       {
        strcat(tempname, ".bugsold");
       }

    if (0 != strcmp(PARAM_KEYFILE, ""))
	{
	 printf("\n Key File : '%s'.",PARAM_KEYFILE);
	}
    printf("\n Clear file : '%s'.",PARAM_SOURCE);
    if (0 == strcmp(PARAM_SOURCE, PARAM_TARGET)) printf("\n Temp file : '%s'.",tempname);
    printf("\n Cipher file : '%s'.\n\n",PARAM_TARGET);
   }
else 
   {
    printf("\n Action : UNCRYPT");
   if (0 == PARAM_POWER)
       printf("\n Power : (0) Standard algorithm.");
    else
       printf("\n Power : (1) Probality algorithm.");
          
    if (0 != strcmp(PARAM_KEYFILE, ""))
	{
	 printf("\n Key File : '%s'.",PARAM_KEYFILE);
	}
    printf("\n Cipher file : '%s'.",PARAM_SOURCE);
    printf("\n Clear file : '%s'.\n\n",PARAM_TARGET);
   }

if (0 == strcmp(PARAM_KEYFILE,""))
   {
          i=0;
          printf(" Password -> ");
          do{
             carac=bcrypt_vol(1);
             if(carac!=RETURN) pass_clear[i]=carac;
             i++;
            }while((i<varinit->NB_CHAR) && (carac!=RETURN));
         if (carac == RETURN)
            {
             pass_clear[i - 1]='\0';
             length = i - 1;
            }
         else
             length = i;

         if(length >= (varinit->NB_CHAR /2))
           {
            /*
             * We want to crypt
             */
            if (1 == PARAM_CRYPT)            
               {
               printf("\n Re-type Passwd -> ");
               i=0;
               do{
                  carac=bcrypt_vol(1);
                  if(carac!=RETURN) pass_verif[i]=carac;
                  i++;
                 }while((i<varinit->NB_CHAR) && (carac!=RETURN));
               
               if (carac == RETURN)
                  {
                   pass_verif[i - 1]='\0';
                   length = i - 1;
                  }
                else
                  length = i;

               if(strcmp((char *) pass_clear,pass_verif)==0)
                 {
                 printf("\n Crypt started, Please Wait.\n");

		 if (0 == strcmp(PARAM_SOURCE, PARAM_TARGET))
		 {
  		  printf(" '%s' renamed to '%s'.\n",PARAM_SOURCE, tempname);
		  rename(PARAM_SOURCE, tempname);
		 }

		 crypt_time = (int)(clock()/CLOCKS_PER_SEC);
                 if(bfile(0,tempname,PARAM_TARGET, "",pass_clear, length,
                    PARAM_POWER, PARAM_VERBOSE, varinit) == 0)
                   {
                   printf("\n ERROR.\n");
                   return 0;
                   }
                  crypt_time = (int)(clock()/CLOCKS_PER_SEC) - crypt_time;

		  if (0 == strcmp(PARAM_SOURCE, PARAM_TARGET))
		  {
	           printf(" Removing temp file...\n");
	           remove(tempname);
		  }
                  printf("\n OK, File crypted in '%d' seconds ...\n", crypt_time);
                  return 1;
                  }
               else status=2;
               }
           /* 
            * We want to uncrypt
            */
           else   
            {
            printf("\n Uncrypt started, Please Wait.\n");
            crypt_time = (int)(clock()/CLOCKS_PER_SEC);
            if (bfile(1,PARAM_SOURCE, PARAM_TARGET,"" ,pass_clear, length,
                PARAM_POWER, PARAM_VERBOSE, varinit)==0)
               {
                printf("\n ERROR.\n");
                return 0;
               }
            crypt_time = (int)(clock()/CLOCKS_PER_SEC) - crypt_time;

             printf("\n OK, File UNcrypted in '%d' seconds ...\n", crypt_time);  
             return 1;
            }

       }
       else status=1;    
      
     if (status==1) printf("\n %d letters minimum and %d letters maximum ...\n",
                      (varinit->NB_CHAR/2), varinit->NB_CHAR);
     if (status==2) printf("\n You misspelled it. No file crypted.\n");
     return 0;
    }
   else
     {
        if (1 == PARAM_CRYPT)   
            {
            length = varinit->NB_CHAR;
            printf("\n Crypt started, Please Wait.\n");

	    if (0 == strcmp(PARAM_SOURCE,PARAM_TARGET))
	    {
 	     printf(" '%s' renamed to '%s'.\n",PARAM_SOURCE, tempname);
	     rename(PARAM_SOURCE, tempname);
	    }
            crypt_time = (int)(clock()/CLOCKS_PER_SEC);
            if(bfile(0,tempname, PARAM_TARGET, PARAM_KEYFILE, pass_clear,
		     length, PARAM_POWER, PARAM_VERBOSE, varinit)==0)           
              {
    printf("\n Key file does not exist or is his length is < KEYLENGTH.\n\n");
                printf("\n ERROR.\n");
	        return 0;
               }
            crypt_time = (int)(clock()/CLOCKS_PER_SEC) - crypt_time;
	
	    if (0 == strcmp(PARAM_SOURCE, PARAM_TARGET))
	     {
	      printf(" Removing temp file...\n");
	      remove(tempname);
	     }

             printf("\n OK, File Crypted in '%d' seconds ...\n", crypt_time);  
             return 1;
            }
           else   
            {
	    length = varinit->NB_CHAR;
            printf("\n Uncrypt started, Please Wait.\n");
            crypt_time = (int)(clock()/CLOCKS_PER_SEC);
            if (bfile(1,PARAM_SOURCE, PARAM_TARGET, PARAM_KEYFILE, pass_clear,
		length, PARAM_POWER, PARAM_VERBOSE, varinit)==0)
               {
    printf("\n Key file does not exist or is his length is < KEYLENGTH.\n\n");
                printf("\n ERROR.\n");
                return 0;
               }
            crypt_time = (int)(clock()/CLOCKS_PER_SEC) - crypt_time;

             printf("\n OK, File UNcrypted in '%d' seconds ...\n", crypt_time);  
             return 1;
            }
      }
}


/*
 * Check the parameter of the program
 */
int argcheck(int argc, char **argv)
    {
	int i;
	FILE *temp_file;

	for (i = 0; i < argc; i++)
	{
	
	if (strcmp(argv[i],"-c") == 0) PARAM_CRYPT=1;
 	else if (strcmp(argv[i],"-u") == 0) PARAM_UNCRYPT=1;
  	else if ((strcmp(argv[i],"-s") == 0) && (i+1 < argc))
		{
	         if (strlen(argv[i+1]) > 200)
		    {
		     printf("\n ERROR. \nSource file name is too long. \n\n");
		     return 0;
		    }
		 PARAM_SOURCE = (char *) malloc(strlen(argv[i+1]) + 1);
		 strncpy(PARAM_SOURCE, argv[i+1],strlen(argv[i+1]));
		}
	 else if ((strcmp(argv[i],"-d") == 0) && (i+1 < argc))
		{
	         if (strlen(argv[i+1]) > 200)
		    {
		     printf("\n ERROR. \nTARGET file name is too long. \n\n");
		     return 0;
		    }
		 PARAM_TARGET = (char *) malloc(strlen(argv[i+1]) + 1);
		 strncpy(PARAM_TARGET, argv[i+1],strlen(argv[i+1]));
		}
	 else if ((strcmp(argv[i],"-f") == 0) && (i+1 < argc)) 
		{
	         if (strlen(argv[i+1]) > 200)
		    {
		     printf("\n ERROR. \nKEY file name is too long. \n\n");
		     return 0;
		    }
		 PARAM_KEYFILE = (char *) malloc(strlen(argv[i+1]) + 1);
		 strncpy(PARAM_KEYFILE, argv[i+1],strlen(argv[i+1]));
		}
	 else if ((strcmp(argv[i],"-k") == 0) && (i+1 < argc)) PARAM_KEYLENGTH=atoi(argv[i+1]);
	 else if ((strcmp(argv[i],"-p") == 0) && (i+1 < argc)) PARAM_POWER=atoi(argv[i+1]);
	 else if (strcmp(argv[i],"-v") == 0) PARAM_VERBOSE=1;
        }	


if (0 == strcmp(PARAM_SOURCE,"")) 
   {
    usage();
    return 0;
   }

if (((0 == PARAM_CRYPT) && (0 == PARAM_UNCRYPT)) ||
   ((1 == PARAM_CRYPT) && (1 == PARAM_UNCRYPT)))
   {
    usage();
    return 0;
   }

if ((temp_file=fopen(PARAM_SOURCE,"rb")) == 0) 
   {
    printf("\n ERROR.");
    printf("\n The file '%s' does not seem to exist.\n\n",PARAM_SOURCE);
    return 0;
    }
fclose(temp_file);

if ((0 == PARAM_UNCRYPT) && (0 == strcmp(PARAM_TARGET,"")))
   {
   PARAM_TARGET = (char *) malloc(strlen(PARAM_SOURCE));
   strcpy(PARAM_TARGET, PARAM_SOURCE);
   }

if ((1 == PARAM_UNCRYPT) && (0 == strcmp(PARAM_TARGET,"")))
   {
    printf("\n ERROR. \n you MUST specify a target file when you uncrypt a file \n\n");
    return 0;
   }

if ((1 == PARAM_UNCRYPT) && (0 == strcmp(PARAM_TARGET, PARAM_SOURCE)))
   {
    printf("\n ERROR. \n SOURCE and DEST files MUST BE different while UNcrypting.\n\n");
    return 0;
   }

if ((0 != strcmp(PARAM_KEYFILE,"")) && ((temp_file=fopen(PARAM_KEYFILE,"rb")) == 0))
   {
    printf("\n ERROR.");
    printf("\n The key file '%s' does not seem to exist.\n\n",PARAM_KEYFILE);
    return 0;
   }
fclose(temp_file);

if (PARAM_KEYLENGTH < 32) 
    {
     printf("\n ERROR.");
     printf("\n KEYLENGTH MUST BE > 32.\n\n");
     return 0;    
    }

if ((PARAM_POWER > 1) || (PARAM_POWER < 0))
    {
     printf("\n ERROR.");
     printf("\n POWER MUST BE 0 or 1.\n\n");
     return 0;
    }

PARAM_KEYLENGTH = (PARAM_KEYLENGTH / 8) * 8;

return 1;
}


void usage()
     {   
      printf("\n BCRYPT %s, (C) Martinez Sylvain",VERSION);
      printf("\n BUGS ALGORITHM CRYPT FILE");
      printf("\n\n Usage: bcrypt [MODE] -s SOURCE_FILE {-d DEST_FILE} {OPTIONS}");
      printf("\n\n  [MODE] : ");
      printf("-c = Crypt file \n");
      printf("           -u = Uncrypt file");
      printf("\n\n Note: If you do not specify a DEST_FILE then the SOURCE_FILE is replaced by the cipher result.");
      printf("\n\n {OPTIONS}");
      printf("\n  -f key_file : Do not type a password but use a file instead");
      printf("\n  -k nb       : KEYLENGTH which has to be a 2 multiple integer.");
      printf("\n	        At least 32.");
      printf("\n	        DEFAULT = 128"); 	
      printf("\n  -p nb       : POWER used to crypt.");
      printf("\n                0 (Standard algorithm, default)");
      printf("\n	        1 (Probability algorithm, stronger !)");  
      printf("\n  -v          : Verbose mode.\n\n"); 
     }        
