/*  
 *  bhide.c
 *
 *  Version 1.3
 *  26 July 1999 
 *
 *   HIDE FILE 
 *
 *   Realised by MARTINEZ Sylvain  
 *
 *   Based on the BUGS crypt's algorithm of MARTINEZ Sylvain  
 *   (Big and Usefull Great Security)  
 *
 *   UNIX Administrator (Merrill Lynch, UK) 
 *   Network Security Consultant (ASI, France)
 *   Passion: Cryptology and Network Security  
 *   email: martinez@asi.fr  
 *          sylvain.martinez@netcourrier.com 
 *   URL: http://www.asi.fr/~martinez
 *
 *  Copyright (C) 1996,1997,1998,1999 MARTINEZ Sylvain  
 *  THIS IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER  
 *  THE TERMS OF THE GNU GENERAL PUBLIC LICENSE, see the file COPYING.  
 */

/*
 * HISTORY
 *
 * --- Version in progress ---
 *
 * 
 * --- V 1.3 ---
 *
 * 26/07/1999 : - Replaced sizeof() by strlen() while calling malloc()
 *
 * 23/07/1999 : - Changed the way I handle parameters
 *
 * --- V 1.2 ---
 * 
 * 16/02/1998 : - Corrected the input password bug
 *		- Changed bcrypt initialisation (binit)
 *
 * --- V 1.1 ---
 *
 * 07/02/1998 : - Minor changes about the informations displayed
 *		- Changed the default flag position to 1 (End of File)
 *              - Added the libcrypt version number
 *
 * --- V 1.0 --- 
 *
 * 27/01/1998 : - First tests
 *
 */

/*
 * This header is important
 * There is some global variables that you will need, eg:
 * USER_LENGTH = size of the string that contain the user name
 * other reserved variable name : KEYLENGTH, varinit->NB_CHAR, varinit->NB_INDEX, etc
 * Read the documentation or have a look of this header for more information
 */
#include "../include/libcrypt.h"
#include "../include/extra.h"

char *VERSION="v1.3, July 1999";

/*
 * Default : mode = 0 (non verbose)
 *           option = 1 (write at the end of file)
 */
  int MODE = 0;
  int PARAM_OPTION = 1;
  int PARAM_CHOICE = 0;
  char *PARAM_SOURCE="";
  char *PARAM_DEST="";
  globalvar *varinit;


/*
 * Functions
 */
void usage(void);
int init(void);
int hide(char **);
int argcheck(int, char **);


int 
main (int argc, char **argv)
{

if (argcheck(argc, argv) == 0) return 0;

if (init() == 0) return 0;

if (hide(argv) == 0) return 0;

return 1;
}

/*
 * Initialised the global variables
 */
int init()
{
varinit = (globalvar *) malloc(sizeof(globalvar));
/*
 * The log will be generated in the stderr output
 * I give a default key length, but I will not use it.
 */
binit(128, 0, varinit);
return 1;
}


/*
 * Hide function 
 */
int hide(char **argv)
{

printf("\n BHIDE %s, Martinez Sylvain",VERSION);
printf("\n HIDE FILE");
printf("\n Libcrypt version : '%s'",varinit->LIB_VERSION);
printf("\n\n Source file : %s.",PARAM_SOURCE);
printf("\n Destination file : '%s'.",PARAM_DEST);
  
if (PARAM_CHOICE == 0)
   {
    printf("\n Hiding data in progress.\n");
    if (bcrypt_write_hide(PARAM_OPTION,PARAM_SOURCE,PARAM_DEST, MODE) == 0)
	{
	 printf("\n ERROR.");
	 printf("\n Writing hide file failed.\n\n");
         return 0;
	}
   }
else 
   {
    printf("\n Extracting hide data in progress.\n");
    if (bcrypt_read_hide(PARAM_OPTION, PARAM_SOURCE, PARAM_DEST, MODE) == 0)
       {
	 printf("\n ERROR.");
	 printf("\n Extracting hide data failed.\n\n");
         return 0;
	}
   }
printf("\n Operation finished.\n\n");
return 1;
}


/* 
 * Check the parameter of the program
 */
int argcheck(int argc, char **argv)
{
int i;

for (i = 0; i < argc; i++)
    {
     if (0 == strcmp(argv[i],"-h")) PARAM_CHOICE = 0;    
     else if (0 == strcmp(argv[i],"-e")) PARAM_CHOICE = 1;
     else if ((0 == strcmp(argv[i],"-s")) && (i+1 < argc))
	     {
		PARAM_SOURCE = (char *) malloc(strlen(argv[i+1]));
		strcpy(PARAM_SOURCE,argv[i+1]);
	     }
     else if ((0 == strcmp(argv[i],"-d")) && (i+1 < argc))
	     {
		PARAM_DEST = (char *) malloc(strlen(argv[i+1]));
		strcpy(PARAM_DEST,argv[i+1]);
	     }
     else if (0 == strcmp(argv[i],"-beg")) PARAM_OPTION = 0;
     else if (0 == strcmp(argv[i],"-end")) PARAM_OPTION = 1;
     else if (0 == strcmp(argv[i],"-v")) MODE = 1;	
    }

if ((0 == strcmp(PARAM_SOURCE,"")) || (0 == strcmp(PARAM_DEST,"")))
   {
    usage();
    return 0;
   }

if (fopen(PARAM_SOURCE,"rb") == 0) 
{
 printf("\n ERROR.");
 printf("\n Source_file '%s' does not seems to exist.\n\n", PARAM_SOURCE);
 return 0;
}

if (0 == PARAM_CHOICE)
{
 if (fopen(PARAM_DEST,"rb") == 0) 
 {
  printf("\n ERROR.");
  printf("\n Dest_file '%s' does not seems to exist.\n\n",PARAM_DEST);
  return 0;
 }
}
else
{
 if (fopen(PARAM_DEST,"rb") != 0)
 {
  printf("\n ERROR.");
  printf("\n Dest_file '%s' ALREADY exists.\n\n",PARAM_DEST);
  return 0;
 }
}             

return 1;
}


void usage()
{
   printf("\n BHIDE %s, (C) Martinez Sylvain",VERSION);
   printf("\n HIDE FILE ");
   printf("\n\n Usage: bhide [MODE] -s SOURCE_FILE -d DEST_FILE {OPTIONS} [-v]");
   printf("\n\n [MODE] : "); 
   printf(" -h     : Hide source_file in dest_file (DEFAULT)");
   printf("\n           -e     : Extract hide data from source_file in dest_file");
   printf("\n\n {OPTIONS} : ");
   printf("\n\n  -beg : Hide data at the begining of a file ");
   printf("\n\n  -end : Hide data at the end of a file (DEFAULT)");
   printf("\n\n  -v   : Verbose mode.\n\n"); 
}
