/*
 *  libcrypt.c
 *
 *
 *  B U G S         LIBRARY  
 *
 *   CRYPTOGRAPHY ALGORITHM
 *   Version 2.0.0 
 *   26 July 1999 
 *
 *  -> make multi-users programms
 *  -> generate passwd
 *  -> crypt file
 *
 *   Realised by MARTINEZ Sylvain
 *
 *   Based on the BUGS crypt's algorithm of MARTINEZ Sylvain
 *   (Big and Usefull Great Security)  
 *
 *   UNIX Administrator (Merrill Lynch, UK) 
 *   Network Security Consultant (ASI, France)
 *   Passion: Cryptology and Network Security
 *   email: martinez@asi.fr
 *          sylvain.martinez@netcourrier.com 
 *   URL: http://www.asi.fr/~martinez
 *
 *  Copyright 1996,1997,1998,1999 MARTINEZ Sylvain
 *  THIS IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER
 *  THE TERMS OF THE GNU GENERAL PUBLIC LICENSE, see the file COPYING.
 */

/*
 * HISTORY
 *
 * --- Version in progress ---
 *
 * 31/10/1999: - I have just changed the library version which was still set 
 *		 to 1.8.0
 *
 * --- V 2.0.0 ---
 *
 * 26/07/1999 : - I have tested this library for weeks now, it should be
 *		  stable. Therefore I start a new number version for this
 *		  library: 2.0.0 
 *
 *
 * 09/07/1999 : - Fixed minor error in read_password(). Now if there is 
 *		  the last user in the password file named toto and 
 *		  you try to logon as "t" then the function won't be
 *		  confused anymore as I now compare the lenght of the
 *		  strings.
 *
 * --- V 1.8.0 ---
 *
 * 18/02/1998 : - Made some modification in the swap function.
 *	          Now the bilateral swap is more powerful and faster !
 * 	        - Corrected some minor bugs.	
 *
 * --- V 1.7.3 ----
 *
 * 16/02/1998 : - Corrected minor bugs in binit() function
 *		- Added an option in binit() : mode = 2
 *
 * 15/02/1998 : - Made some modifications to bfile, added a parameter.
 *		  Now everything seems to work fine on Windows95, even
 *		  even with very large KEY.
 *              - Cleaned the source code.
 *		- Removed some useless log
 *		- Corrected minor error in bkey_generator function.
 *
 * 14/02/1998 : - Made some modifications to several functions to make them
 *		  work with Windows95 :
 *		  binit(), bkey_generator(), bhide()
 *
 * 13/02/1998 : - Fixed a problem with Windows95 : you can not send in parameter
 *		  a string > 255 characters to a DLL !
 *
 * --- V 1.7.2 ---
 *
 * 12/02/1998 : - Added the fflush() function after any fprintf
 *		- I added a parameter to binit() : int mode
 *		  mode = 0 -> stderr
 *		  mode = 1 -> file
 *		- I can now generate some log with Windows95
 *		- Fixed minor bugs
 *
 * 11/02/1998 : - Fixed a BIG bug in test_length function :
 *		  Sometimes, with bkey_generator function I could have a
 *		  very small input text, 0 or 2 characters ...
 *		  Because I sometimes had '/0' in the string.
 *                Now I have one more parameter the external functions :
 *		  int length, which is the length of the clear password sent
 *		  in parameter.
 *		  Thanks to that, your cipher password can contain '/0'
 *
 * --- V 1.7.1 ---
 *
 * 07/02/1998 : - Cleaned the source code
 *              - Changed the write hide algorithm to make it compatible
 *	          with Windows 95 DLL.
 *              - Added a new global variable : LIB_VERSION
 *
 * --- V 1.7.0 ---
 *
 * 03/02/1998 : - Added bpow function, a power function
 *
 * 29/01/1998 : - Small modification for compibility with Borland C++
 *	          Builder on Windows95
 *
 * 28/01/1998 : - Added the backup file in write_hide function
 *
 * 27/01/1998 : - Fixed some bugs in bkey_generator function
 *	        - Added a Check for 0 value in swap and code functions
 * 	        - Added write_key_file and read_key_file functions
 *	        - Added write_hide and read_hide functions
 *	        - Added delete_passwd function
 *
 * 26/01/1998 : - Added the bkey_generator function, use it to generate long
 *		  key. (key = clear text that will be use to do a passwd)
 *		  You can initialise the key generation with a random
 *		  number or with 8 characters.
 *
 * --- V 1.6.3 ---
 *
 * 20/01/1998 : - Fixed a bug in the bcrypt write function, when I had to
 *		  write at the end of a file some data, which the length was
 *		  inferior to varinit->NB_CHAR.
 *
 * 19/01/1998 : - Problem with a variable global : USER_LENGTH, I added it to
 *		  varinit, I had some problem with this variable and with
 *		  malloc
 *		- Problem in write_passwd function, variable utilisation (pos)
 *
 * 17/01/1998 : - Minor problem in test passwd function, I used a ** type,
 *		  and I had a problem with that on Windows95, hum, hum ...
 *
 *
 * --- V 1.6.2 ---
 *
 * 16/01/1998 : - Resolved a bug in the probability crypt function
 *		  Problem with an array's border :
 *		  j = 0 when it was suppose to be j = 1
 *
 * 15/01/1998 : - Minor changes to make my library works on a Silicon Graphics
 *
 * 14/01/1998 : - Resolved the problem with bpass parameter : passwd
 *		  when I wanted to use my DLL on Windows 95
 *		  (who said windows95 = error ??? ;o)
 *		  Now, I do not have a TYPE_INT ** type anymore,
 *		  So it is the program that call this library that
 *		  has to reserve memory for the passwd variable (malloc)
 *		  Maybe a bit less easy to use, but more compatible ...
 *
 * 13/01/1998 : - Added Windows 95 DLL's compatibility
 *		  with #if defined(__WIN32__)
 *		- I also removed my global variables because it was a problem
 *		  when I tried to use my library on Windows95
 *		  so I have now a pointer in parameter of each function :
 *                *varinit, and a new type : globalvar
 *
 * 12/01/1998 : - write_passd and read_passwd functions:
 *		  windows 95 problem's compatibility with typedef => resolved
 *
 * 11/01/1998 : - Bugs corrections in bfile and bcrypt_write_file_prob
 *		  Problem of aray initialisation and variable init :
 *		  pass_key and code_key
 *		- Removed all extra functions (bcrypt_vol,etc)
 *             	- Started to do an HISTORY
 */

/*
 * That is my own header
 */
 #include "../include/libcrypt.h"

/*
 * Compatibility with Windows 95 Borland C++ DLL
 * If you use Borland C++ 4.5 or laster you have to replace the
 * line : RETURN_TYPE int FAR PASCAL
 * by :  RETURN_TYPE int FAR PASCAL _export
 */
#if defined(__WIN32__)
#define RETURN_TYPE int FAR PASCAL
#else
#define RETURN_TYPE int
#endif

/*********************************************************
 *                      FUNCTIONS                         
 *********************************************************/


/*
 *  PRINCIPAL FUNCTIONS
 * ---------------------
 */


/*
 * INIT FUNCTION
 * The global variables will be initiallized
 * mode = 0  : stderr log output
 * mode = 1  : file log output
 * mode = 2  : internal binit call, no redefinition on the error output
 */
RETURN_TYPE binit(int length, int mode, globalvar *varinit)
{

if (mode == 0)
   {
   BCRYPTLOG = stderr;
   fprintf(BCRYPTLOG, "\n ---- INITIALISATION ---- \n");
   fflush(BCRYPTLOG);
   }

if (mode == 1)
   {
   BCRYPTLOG = fopen("bcrypt.log","a+b");
   fprintf(BCRYPTLOG, "\n ---- INITIALISATION ---- \n");
   fflush(BCRYPTLOG);
   }
/*
 * NB_BYTE's value is the number of bit of the integer that I use
 * in this algorithm and defined by TYPE_INT
 */
varinit->NB_BYTE = sizeof(TYPE_INT);

/* How many bits in your key ?
 * default is 128 bits = 16 characters
 * minimum is 64 = 8 characters
 * Always use number that are a multiple of 2 !!
 * and ALWAYS >= 64 ! if you want something usefull
 * and ALWAYS >= 32 ! if you want that's work
 */ 
if (length < 32) varinit->KEYLENGTH = 128;
   else varinit->KEYLENGTH = length;


varinit->NB_INDEX = ((varinit->KEYLENGTH / 8) / varinit->NB_BYTE);
varinit->NB_CHAR = (varinit->KEYLENGTH / 8);

/*
 * I only use these variables for the swap function
 */
varinit->NB_INDEX_DOUBLE = ((varinit->KEYLENGTH / 4) / varinit->NB_BYTE);
varinit->NB_CHAR_DOUBLE = (varinit->KEYLENGTH / 4);

varinit->USER_LENGTH = 20;

strncpy(varinit->LIB_VERSION,"2.0.0",10);

return 1;
}

/*
 * KEY GENERATOR function
 * 
 * Generate long key in a file
 * Minimum key length : 128
 *
 */
RETURN_TYPE
bkey_generator (unsigned char *pass_param, int length, char *file_path,
		        int power, int random, int mode, globalvar *varinit)
{
  int clock, i, j, k, l, shift;
  TYPE_INT *swap_length, *pass_code, bit_operations[3];
  globalvar *varsaved;
  unsigned char *pass_clear;


if (varinit->KEYLENGTH < 128)
   {
    if (mode == 1)
       {
        fprintf(BCRYPTLOG, "\n You can only generate key >= 128 bits.");
        fflush(BCRYPTLOG);
       }
    fclose(BCRYPTLOG);
    return 0;
   }
/*
 * pass_code will receive the numerical value of the characters
 * swap_length will receive the different lengths of the different swaps
 */
swap_length = (TYPE_INT *) malloc (varinit->NB_CHAR_DOUBLE);
pass_code = (TYPE_INT *) malloc (varinit->NB_CHAR);
pass_clear = (unsigned char *) malloc (varinit->NB_CHAR);

if (power == 0)
{
if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n Key generator function started.");
    fprintf(BCRYPTLOG, "\n Key length that will be generated : %d.",
    							varinit->KEYLENGTH);
    fprintf(BCRYPTLOG, "\n Standard maximum random number : %d.",RAND_MAX);
    fprintf(BCRYPTLOG, "\n New size of the random number in bits : %d.",
						    (varinit->NB_BYTE * 8));
    fflush(BCRYPTLOG);
   }

varsaved = (globalvar *) malloc(sizeof(globalvar));

if (random == 0)
     for (i = 0; i < length; i ++) pass_clear[i] = pass_param[i];

binit(128, 2, varsaved);

if (random == 1)
    {
/*
 * I take the time
 */
      clock = (int) time (NULL);

/*
 * I initialise the random sequence on the time
 */
      srand (clock);

if (mode == 1)
   {
    fprintf(BCRYPTLOG,"\n Random initialisation in progress.");
    fflush(BCRYPTLOG);
   }

for (i = 0; i < varsaved->NB_CHAR; i++)
    pass_clear[i] = (char) rand();

length = varsaved->NB_CHAR;
     }

else
    {
     fprintf(BCRYPTLOG, "\n Initialisation already done.");
     fflush(BCRYPTLOG);
    }

i = 128;

do
  {
if (mode == 1)
    {
     fprintf(BCRYPTLOG,"\n Current length key = %d.",i);
     fflush(BCRYPTLOG);
    }

      if (bcrypt_test_length (pass_clear, length, mode, varsaved) == 0)
         {
        fclose(BCRYPTLOG);
        return 0;
        }

      if (bcrypt_transcription (pass_clear, pass_code, swap_length,
          bit_operations, mode, varsaved) == 0)
          {
          fclose(BCRYPTLOG);
		  return 0;
          }

      if (bcrypt_add (pass_code, swap_length, mode, varsaved) == 0)
         {
         fclose(BCRYPTLOG);
         return 0;
	     }
      if (bcrypt_swap (swap_length, pass_code, bit_operations,
                                                    mode, varsaved) == 0)
         {
         fclose(BCRYPTLOG);
         return 0;
		 }
      if (bcrypt_code (0, 0, pass_code, pass_clear, mode, varsaved) == 0)
         {
         fclose(BCRYPTLOG);
         return 0;
         }
/*
 * We translate the long integer from pass_code into some characters
 * in the string pass_clear
 */
l=0;
k=0;
j=0;
    do
     {
       if (l == 0) shift = 24;
         else
       shift = shift - 8;

       pass_clear[j] = (int)((pass_code[k] << shift) >> 24)%256;

       l++;
       if (l == varsaved->NB_BYTE)
          {
           l = 0;
           k++;
          }
        j++;

       }
      while (k < varsaved->NB_INDEX);

      i = i * 2;
      length = varsaved->NB_CHAR;
      binit(i, 2, varsaved);

     } while (i <= varinit->KEYLENGTH);

     if (bcrypt_write_keyfile (pass_clear, file_path, mode, varinit) == 0)
        {
         fclose(BCRYPTLOG);
         return 0;
        }

      if (mode == 1)
         {
          fprintf(BCRYPTLOG, "\n Key generator function finished.");
         fflush(BCRYPTLOG);
         }
      fclose(BCRYPTLOG);
      return 1;
    }
  else
    {
      fprintf (BCRYPTLOG, "\n ERROR: Power level '%d' NOT AVAILABLE \n", power);
	  fflush(BCRYPTLOG);
	  fclose(BCRYPTLOG);
      return 0;
    }
}


/*
 * LOGIN FUNCTION
 * that will check if the passwd will be the same than the one
 * sent in parameter.
 * This is a function for a character string parameter
 */
int
blogin (TYPE_INT *code_file, unsigned char *pass_clear, int length, int power,
        int mode, globalvar *varinit)
{

 if (power == 0)
 {
/*
 * eg. : if varinit->KEYLENGTH = 128 bits = 16 characters
 *       I check if the string has, at least, 16 / 2 = 8 characters
 *       Because if the string is smaller it could be weak.
 */
   if (mode == 1)
      {
       fprintf (BCRYPTLOG,"\n Check passwd started.");
       fflush(BCRYPTLOG);
      }

   if ( (length >= (varinit->NB_CHAR / 2) ) &&
        bcrypt_test_passwd (power, code_file, pass_clear, length, mode,
                             varinit) != 0)
        return 1;
      else
        return 0;
  }

  fprintf (BCRYPTLOG, "\n ERROR: Power level '%d' NOT AVAILABLE \n", power);
  fflush(BCRYPTLOG);
  return 0;
}

/*
 * PASSWD CRYPT FUNCTION
 * use a string of character in input
 */
int
bpass (TYPE_INT *pass_code, unsigned char *pass_clear, int length,int power,
       int mode, globalvar *varinit)
{

  TYPE_INT *swap_length, bit_operations[3];

/*
 * pass_code will receive the numerical value of the characters
 * swap_length will receive the different lengths of the different swaps
 */
swap_length = (TYPE_INT *) malloc (varinit->NB_CHAR_DOUBLE);


if (power == 0)
{

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n Crypt passwd started.");
    fprintf(BCRYPTLOG, "\n Length of the passwd typed in BYTES = %d.",
							length);
    fprintf(BCRYPTLOG, "\n Standard maximum random number : %d.",RAND_MAX);
    fprintf(BCRYPTLOG, "\n New size of the random number in bits : %d.",
						    (varinit->NB_BYTE * 8));
    fflush(BCRYPTLOG);                            
   }

      if (bcrypt_test_length (pass_clear, length, mode, varinit) == 0)
        {
        return 0;
        }

      if (bcrypt_transcription (pass_clear, pass_code, swap_length,
          bit_operations, mode, varinit) == 0)
          {
  	   return 0;
          }
      if (bcrypt_add (pass_code, swap_length, mode, varinit) == 0)
         {
         return 0;
         }
      if (bcrypt_swap (swap_length, pass_code, bit_operations,
                                                    mode, varinit) == 0)
         {
         return 0;
         }

      if (bcrypt_code (0, 0, pass_code, pass_clear, mode, varinit) == 0)
         {
         return 0;
         }

      if (mode == 1)
         {
          fprintf(BCRYPTLOG, "\n Crypt passwd finished.");
          fflush(BCRYPTLOG);
         }
      return 1;

    }
  else
    {
      fprintf (BCRYPTLOG, "\n ERROR: Power level '%d' NOT AVAILABLE \n", power);
	  fflush(BCRYPTLOG);
      return 0;
    }
}


/*
 * FILE CRYPT FUNCTION
 * choice = 0 : crypt
 * choice = 1 : uncrypt
 * power = 0  : standard algorithm
 * power = 1  : probability algorithm
 * if you do not want to use a key file, you have to send a void string in
 * parameter ("")
 */
RETURN_TYPE
bfile (int choice, char *name_clear, char *name_code, char *name_key,
       unsigned char *pass_param, int length_pass, int power, int mode,
       globalvar *varinit)
      {

  TYPE_INT *pass_code, *swap_length, bit_operations[3];

  FILE *file_clear, *file_code, *file_key;
  int i, length_file, length_tab;
  int *fich_tab;

  int k,l,shift;
  unsigned char *pass_key, *pass_clear;
  TYPE_INT *code_key;

if ((power != 0) && (power != 1))
 {
   fprintf (BCRYPTLOG, "\n ERROR: Power level '%d' NOT AVAILABLE \n", power);
   fflush(BCRYPTLOG);
   fclose(BCRYPTLOG);
   return 0;
 }

pass_clear = (unsigned char *) malloc( varinit->NB_CHAR);
pass_key = (unsigned char *) malloc (varinit->NB_CHAR);
pass_code = (TYPE_INT *) malloc (varinit->NB_CHAR);
code_key = (TYPE_INT *) malloc (varinit->NB_CHAR);
swap_length = (TYPE_INT *) malloc (varinit->NB_CHAR_DOUBLE);

if (mode == 1)
 {
  fprintf (BCRYPTLOG, "\n\n Crypt File function started.");
  fprintf (BCRYPTLOG, "\n POWER : %d.",power);
  if(choice == 0)
   {
    fprintf (BCRYPTLOG, "\n Filename crypted : %s.",name_code);
    fprintf (BCRYPTLOG, "\n Filename to crypt : %s.",name_clear);
    fprintf(BCRYPTLOG, "\n Action : Crypt File.");
   }
  else
     {
      fprintf(BCRYPTLOG,"\n Filename crypted : %s.",name_clear);
      fprintf(BCRYPTLOG,"\n Filename uncrypted : %s.",name_code);
      fprintf(BCRYPTLOG,"\n Action : Decrypt File.");
     }
   fflush(BCRYPTLOG);
 }


  file_clear = fopen (name_clear, "rb");
  if (file_clear == NULL)
   {
    if (mode == 1)
       fprintf(BCRYPTLOG,"\n ERROR. Source file does not seem to exist.");
    fflush(BCRYPTLOG);
    fclose(BCRYPTLOG);
    return 0;
    }

  file_key = fopen (name_key, "rb");
  if (file_key != NULL)
   {
     fseek(file_key, 0, 2);
     if (ftell(file_key) < varinit->NB_CHAR)
         {
         if (mode == 1)
         fprintf(BCRYPTLOG,"\n ERROR. Key file length < KEYLENGTH.");
         fflush(BCRYPTLOG);
         fclose(BCRYPTLOG);
         return 0;
        }

     fclose(file_key);

     if (bcrypt_read_keyfile(pass_clear, name_key, mode, varinit) == 0)
         {
          if (mode == 1)
             fprintf(BCRYPTLOG,"\n ERROR. Read key file failed.");
         fflush(BCRYPTLOG);
         fclose(BCRYPTLOG);
         return 0;
         }
   }
   else
   {
    for (i = 0; i < length_pass; i++) pass_clear[i] = pass_param[i];
   }

/*
 * That allows me to know the length of a file in BYTES
 */
  fseek (file_clear, 0, 2);
  length_file = ftell (file_clear);
  fseek (file_clear, 0, 0);

  length_tab = (length_file / varinit->NB_CHAR);

  if ((length_tab * varinit->NB_CHAR) < length_file) length_tab++;

   if ((power == 1) && (choice == 0)) length_tab++;

if (mode == 1)
   {
   fprintf (BCRYPTLOG, "\n Length's Source File : %d.",length_file);
   fprintf (BCRYPTLOG, "\n Nb of filter for this file : %d.",length_tab);
   fprintf(BCRYPTLOG, "\n Standard maximum random number : %d.",RAND_MAX);
   fprintf(BCRYPTLOG, "\n New size of the random number in bits : %d.",
						    (varinit->NB_BYTE * 8));
   fflush(BCRYPTLOG);
   }

  fich_tab = (int *) malloc (length_tab * sizeof(int));
  for (i = 0; i < length_tab; i++)
    fich_tab[i] = 0;

  if ( length_pass < (varinit->NB_CHAR / 2) )
  {
  if (mode == 1)
     {
     fprintf (BCRYPTLOG, "\n Wrong password length : %d. / %d.", length_pass,
     varinit->NB_CHAR);
     fflush(BCRYPTLOG);
     }
     fclose(BCRYPTLOG);
     return 0;
    }


  file_code = fopen (name_code, "wb");
  if (file_code == NULL)
  {
  if (mode == 1)
     {
     fprintf (BCRYPTLOG, "\n Can not open destination file.");
     fflush(BCRYPTLOG);
     } 

  fclose(BCRYPTLOG);
    return 0;
  }

if (power == 0)
 {

/**** NOTE for power 0****/
/* In fact, if we crypt again with the same passwd it is like
 * if we uncrypt the file ...
 * Indeed, I do a ^ (EXCLUSIVE OR) and if we do that 2 times, the file is not
 * crypted any more.
 * I still have a variable that you can initialised to know if you
 * want to crypt or uncrypt, in case of I change my algorithm.
 */

 if (bcrypt_test_length (pass_clear, length_pass, mode, varinit) == 0)
     {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
     }


  if (bcrypt_transcription (pass_clear, pass_code, swap_length,
      bit_operations, mode, varinit) == 0)
    {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
    }

  if (bcrypt_add (pass_code, swap_length, mode, varinit) == 0)
     {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
    }

  if (bcrypt_swap (swap_length, pass_code, bit_operations,
                                                mode, varinit) == 0)
    {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
    }

/*
 * I do not add any random number to the passwd
 */

  if (mode == 1)
     {
      if (choice == 0)
         fprintf(BCRYPTLOG, "\n Crypt file process Initiated.");
      else
         fprintf(BCRYPTLOG, "\n Uncrypt file process Initiated.");
      fflush(BCRYPTLOG);
      }

 if(bcrypt_write_file (file_clear, file_code, fich_tab, length_tab,
		pass_code, swap_length, bit_operations, mode, varinit) == 0)
        {
        fclose(BCRYPTLOG);
        return 0;
        }
 else
  {
  fclose(BCRYPTLOG);
  return 1;
  }
}


if (power == 1)
  {
 if (bcrypt_test_length (pass_clear, length_pass, mode, varinit) == 0)
     {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
     }

  if (bcrypt_transcription (pass_clear, pass_code, swap_length,
      bit_operations, mode, varinit) == 0)
    {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
    }

  if (bcrypt_add (pass_code, swap_length, mode, varinit) == 0)
     {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
    }

  if (bcrypt_swap (swap_length, pass_code, bit_operations, mode,
                                                        varinit) == 0)
    {
      fclose (file_code);
      fclose (file_clear);
      fclose(BCRYPTLOG);
      return 0;
    }

if (choice == 0)
    {
/*
 * We translate the long integer from pass_code into some characters
 * in the string pass_clear
 */
l=0;
k=0;
i=0;
    do
     {
       if (l == 0) shift = 24;
         else
       shift = shift - 8;

       pass_key[i] = (int)((pass_code[k] << shift) >> 24)%256;

       l++;
       if (l == varinit->NB_BYTE)
          {
           l = 0;
           k++;
          }
        i++;

       }
      while (k < varinit->NB_INDEX);

    if (bpass (code_key, pass_key, length_pass, 0, mode, varinit) == 0)
        {
         fclose (file_code);
         fclose (file_clear);
/*
 * I do not close BCRYPTLOG because It has been already done
 * in bpass function.
 */
         return 0;
        }

    }

    if (mode == 1)
      {
       if (choice == 0)
          fprintf(BCRYPTLOG, "\n Crypt file process Initiated.");
       else
          fprintf(BCRYPTLOG, "\n Uncrypt file process Initiated.");
       fflush(BCRYPTLOG);
      }

 if(bcrypt_write_file_prob (choice, file_clear, file_code, fich_tab,
			    length_tab, pass_code, pass_clear, code_key,
                            swap_length, bit_operations, mode, varinit) == 0)
 {
 fclose(BCRYPTLOG);
 return 0;
 }
 else
 {
 fclose(BCRYPTLOG);
 return 1;
 }
}
fclose(BCRYPTLOG);
return 0;
}


/*
 *  CRYPT FUNCTIONS
 * -----------------
 */


/*
 * TEST LENGTH FUNCTION
 * To use when the key is a typed passwd
 * (cipher string = when the string has been crypted)
 * to make my crypt algorithm stronger the length of the cipher string
 * has to be static and do not depend on the clear string's length.
 */
int bcrypt_test_length (unsigned char *pass_clear, int length_pass, int mode,
                                                   globalvar *varinit)
{
  int i = 0, j = 0, nb, x, y, xy = 0;
  unsigned char *pass_clear_saved;


  pass_clear_saved = (unsigned char *) malloc(varinit->NB_CHAR);


 if (mode == 1)
    {
     fprintf(BCRYPTLOG,"\n\n Test length function started.");
     fprintf(BCRYPTLOG, "\n length of the input string : %d.",length_pass);
     fflush(BCRYPTLOG);
    }

  if (length_pass < varinit->NB_CHAR)
    {

      for (i = 0; i < length_pass; i++) pass_clear_saved[i] = pass_clear[i];

      x = (int) pass_clear[length_pass - 2];
      y = (int) pass_clear[length_pass - 1];

      nb = varinit->NB_CHAR - length_pass;

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n Nb of character to add : %d.",nb);
    fflush(BCRYPTLOG);
   }

/*
 * We check where we can add some data in the string
 * we first test if x+y is an available position
 * if not we do that :
 * if xy=25, then x=2 and y=5
 * and we try the position x+y.
 * we do that until we find a rigth position
 */
     do
	{
	  xy = x + y;

/*
 * in case of a situation like that : xy = 9 and length_pass = 8
 */
if ((xy < 10) && (xy > length_pass)) xy = (length_pass / 2);

          x = xy / 10;
	  y = xy - ((xy / 10) * 10);

	}
      while (xy > length_pass);
    }
  else return 1;

  for (i = xy, j = (varinit->NB_CHAR - (length_pass - xy));
                                          j < varinit->NB_CHAR; i++, j++)
      pass_clear_saved[j] = pass_clear[i];

/*
 * the data that we add respect the following relation :
 * pseudo_random char of the passwd ^ another pseudo_random char of
 * the passwd
 */
  for (i = xy, j= 0  ; j < nb; i++, j++)
  {
    pass_clear_saved[i] = (char)
     (pass_clear[j] ^
       pass_clear[(unsigned int)pass_clear[j] % (length_pass - 1)]);

   }


for (i = 0; i < varinit->NB_CHAR; i++) pass_clear[i] = pass_clear_saved[i];

if (mode == 1)
   {
    fprintf(BCRYPTLOG,"\n Test length function finished.");
    fflush(BCRYPTLOG);
   }
return 1;
}


/*
 * TRANSCRIPTION FUNCTION
 * This Function transform the passwd letters in number
 * So I have a new string (Let's call it number string)
 * And I calculate the length of the step used in the swap function
 */
int bcrypt_transcription
  (unsigned char *pass_clear, TYPE_INT *pass_code, TYPE_INT *swap_length,
   TYPE_INT *bit_operations, int mode, globalvar *varinit)
{

  int i, j, k, shift;

  if (mode == 1)
     {
      fprintf(BCRYPTLOG, "\n\n Passwd transcription started.");
      fflush(BCRYPTLOG);
     }

for (i = 0; i < (varinit->NB_CHAR / varinit->NB_BYTE); i++)
    {
     pass_code[i]=0;
    }
i=0;
j=0;

do
 {
  for(k = 0; (k < varinit->NB_BYTE) &&  (j < varinit->NB_CHAR ); k++)
      {
       if (k == (varinit->NB_BYTE - 1)) shift = 0;
         else
        shift = 8;

       pass_code[i] |= pass_clear[j];
       pass_code[i] = (pass_code[i] << shift);

       j++;
       }

/*
  * If pass_code[i] = 0 there is only bits = 0 and the swap section
  * may be weak because of that.
  * so I put the best pattern possible : 1010101010101010......
  * for 8 bits : 10101010 = 170
  * for 16 bits it's 170 * 256 , 24 bits = 170 * 256 * 256
  * 32 bits = 170 * 256 ^ 3 , etc
  */

 if (pass_code[i] == 0)
    {
     pass_code[i] =0 - (170 * bpow(256,(varinit->NB_BYTE - 1)));
    }

   i++;
}
while (j < varinit->NB_CHAR );


/*
 * The first swap can be big,
 * eg. : keylength 128 bits
 *       swap_length max = 128 - 2 = 126
 *       only one swap between bit 0 and 127
 * The second swap cannot be big,
 * eg. : keylength 128 bits
 *       swap_length max = 64 - 2 = 62
 *       at least 126 - 62 = 64 swaps
 * 128 bits => (64 * 4 + 4) * 2 = 520 swaps at least
 * (if I do *2 it is because 2 bits are swap each time)
 * 256 bits => (128 * 4 + 4) * 2 = 1032 swaps at least
 * Like that I will be sure to allow big swap and small swap
 */
  for (i = 0, j = 0; j < (varinit->NB_INDEX_DOUBLE); i++, j = j + 2)
    {
     if ((swap_length[j] = pass_code[i] % (varinit->KEYLENGTH - 2)) < 0)
            swap_length[j] = 0 - swap_length[j];
     if ((swap_length[j + 1] =
    (pass_code[i] << (varinit->NB_BYTE * 8 / 2))%
                               ((varinit->KEYLENGTH - 2) / 2)) < 0)
             swap_length[j + 1] = 0 - swap_length[j + 1];
    }


  for (i = 0; i < 3; i++)
      {
       bit_operations[i] = ((unsigned int) pass_clear[i]) % 3;
      }
       
if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Passwd transcription finished.");
   fflush(BCRYPTLOG);
   } 
return 1;
}


/*
 * ADDITIONAL FUNCTION
 * small efficient crypt step.
 * But I prefer to do not use directly the value of the string typed by
 * the user (let's call it clear string).
 * So I will add a value (value in function of the clear string) to each
 * number of the number string (see before).
 */
int 
bcrypt_add (TYPE_INT *pass_code, TYPE_INT *swap_length, int mode,
            globalvar *varinit)
{
  int i;
  TYPE_INT add_number = 1, length_int = 0;
 
  i = 0;

/*
 * To know what is the bigest int possible, I have to change the value of his
 * bits to 1 except the sign bit.
 */
for (i = 0; i <((varinit->NB_BYTE * 8) - 2); i++)
   {
    length_int |= 1;
    length_int = (length_int << 1);
  }

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n\n Additional function started.");
   fflush(BCRYPTLOG);
   }
/*
 * I add all the number contain in swap_length
 * with the number contain in pass_code
 */

   for (i = 0; i < varinit->NB_INDEX_DOUBLE; i++)
              add_number = (add_number * swap_length[i]) % length_int;

   if (add_number < 0) add_number = 0 - add_number;

   for (i = 0; i < varinit->NB_INDEX; i++)
	  pass_code[i] = pass_code[i] ^ add_number;
    
if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Additional function finished.");
   fflush(BCRYPTLOG);
   }
return 1;
}


/*
 * SWAP FUNCTION
 *
 * That is the main part of the crypt algorithm.
 * I will swap bits between them.
 * I just do like if all my number contain in my aray are a only one
 * long string of bits.
 * 
 * Each swap is between 2 bits that are distant of X bits, and X
 * will change in function of the initial passwd typed by the user.
 *
 * eg. :
 * If X=5, we swap the bit 0 with the bit 6 because 5 bits have to be between 
 * them.
 * then I start again with the bits 1 and 7, 2 and 8, etc...
 * I call that a swap cycle with n swap while it occurs.
 * An other cycle will have a different X.
 * 
 * I also use this algorithm a second time, but instead of doing a swap
 * I do a LOGICAL operation on the bit (OR, AND, NOR, etc)
 *
 */
int 
bcrypt_swap (TYPE_INT *swap_length, TYPE_INT *pass_code,
             TYPE_INT *bit_operations, int mode, globalvar *varinit)
{
  int z, j, i, i2, i_rigth, i2_rigth, direction, x;
  int tempa, tempb, indexa, indexb;
  int shift, bits, nb;

  TYPE_INT *a, *b;


if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n\n Bcrypt_swap function Started.");
   fflush(BCRYPTLOG);
   }
shift = 0;
i = varinit->NB_BYTE * 8;
bits = i;
while (i >= 2)
{
 shift++;
 i = i / 2;
}

/*
 * Here we go to swap bits !
 */

/*
 * I alternate swap from the left and from the and.
 * I do that because I noticed that if I only do from the left,
 * the bits in the left may be push on the rigth, rather to have
 * as chance to stay on the left or in the middle as to be on
 * the rigth.
 * As well, that could be a weak point of the alforithm if I did not do that
 * because you could find a sequence in the swapping bit.
 */
      direction = 0;
      i = 0;
      j = 0;

      do
	    {
        x = swap_length[(j  % varinit->NB_INDEX_DOUBLE)];
        direction = (direction  + 1)% 2;

	     /*
              * a is the addresse of the aray's index
              * where is located the bit i
              * b is the addresse of the aray's index
              * where is located the bit i+x+1
              * To know where the bits are located I use a shift
              * indeed, I have to divide i by the number of bit
              * used to store one number in the aray
              * If it is 32 bits, I have to divide by 32
              * but I can do a right shift of 5 instead because
              * doing that is the same thing.
              */

if (direction == 0)
   {
          /*
          * I swap from the left to the rigth
          */

	      a = &pass_code[i >> shift];

          /*
           * if the second bit is out of the range, I take it
           * from the BEGINNING of the bit string ( = cycle)
           */
          if ((i + x + 1) > varinit->KEYLENGTH) i2 =
               ((i + x + 1) - (varinit->KEYLENGTH));
          else
          	i2 = i + x +1;

          b = &pass_code[i2 >> shift];
   }
else
   {
          /*
           * I swap from the rigth to the left
           */
   		  i_rigth = (varinit->KEYLENGTH - 1 - i);

	      a = &pass_code[i_rigth >> shift];

          /*
           * if the second bit is out of the range, I take it
           * from the END of the bit string ( = cycle)
           */
          if ((i_rigth - x - 1) < 0) i2_rigth =
          		(varinit->KEYLENGTH + i_rigth - x - 1);
          else
          	i2_rigth = i_rigth - x - 1;

	      b = &pass_code[i2_rigth >> shift];
   }

	     /*
              * indexa = which bit in the aray's index
              * I have to swap
              * indexb = same thing
              */

   if (direction == 0)
      {
	      indexa = i % bits;
	      indexb = i2 % bits;
      }
   else
      {
   	      indexa = i_rigth % bits;
	      indexb = i2_rigth % bits;
      }

             /*
              * (*a >> indexa) shift the bits of the aray's index
              * where I have to swap the bit.
              * Like that, the bit that I want to swap is the bit
              * the most in the rigth.
              * We do a %2 to know if this bit is a 1 or a 0
              * Indeed, because the bit is the most in the rigth,
              * if this bit is 1, the number will be impair,
              * and a modulo of an impair number always equal
              * to 1 !
              */

	      tempa = (*a >> indexa) % 2;
	      tempb = (*b >> indexb) % 2;

              /*
               * (1 << indexa) put the number 1 on the bit located
               * at the same place of the bit that will be swaped.
               * Then we take his complementary and we do a LOGICAL AND
               * that will put this number to 0, whatever was is
               * previous value (0 or 1) because we always do
               * LOGICAL AND with a 0.
               * Because all the over bits are set to 1, they
               * will not change the value of the other bits
               * in the aray.
               */

	      *a &= ~(1 << indexa);
	      *b &= ~(1 << indexb);

	     /*
              * We put the bit that we want to swap in the new
              * position where we want it to be.
              * We do a LOGICAL OR to put it in the new
              * position.
              * Indeed, because we put in the previous
              * operation the bit to 0 :
              * 0 | 0 = 0
              * 1 | 0 = 1
              */

	      *a |= (tempb << indexa);
	      *b |= (tempa << indexb);

if (direction == 1) i++;
j++;

	     }
         while(i < varinit->KEYLENGTH);

/*
 * I have 3 differents operations available
 * I use the same algorithm that I use to swap bits
 * But here, instead of swaping bits, I do a
 * LOGICAL operation
 */
j = 0;
i = 0;
z = 0;

      do
	    {
        x = swap_length[(z  % varinit->NB_INDEX_DOUBLE)];


              a = &pass_code[i >> shift];
    
          if ((i + x + 1) > varinit->KEYLENGTH) i2 =
               ((i + x + 1) - (varinit->KEYLENGTH));
          else
          	i2 = i + x +1;

              b = &pass_code[i2 >> shift];

             /*
              * indexa = which bit in the aray's index
              * I have to use for the operation
              * indexb = same thing
              */

              indexa = i % bits;
              indexb = i2 % bits;

             /*
              * (*a >> indexa) shift the bits of the aray's index
              * where I have to do an operation on it.
              * Like that, the bit that I want to change is the bit
              * the most in the rigth.
              * We do a %2 to know if this bit is a 1 or a 0
              * Indeed, because the bit is the most in the rigth,
              * if this bit is 1, the number will be impair,
              * and a modulo of an impair number always equal
              * to 1 !
              */

              tempa = (*a >> indexa) % 2;
              tempb = (*b >> indexb) % 2;

               j++;
               j = j % 3;

/* 
 * I noticed something strange, 
 * if I have the operations : (tempa | tempb) or (tempa & tempb)
 * with the bcrypt_file function that generate a lot of passwd
 * (about 1200 for a 100 ko file) , the cipher text has more and
 * more 0  !!!
 * So after a while (like after 400 passwd generations), my passwd
 * has got only 0 !!
 * And doing a LOGICAL OR with only 0, is quite ... weak !
 * So it's why I have only 3 LOGICAL operations that do not 
 * put 0 in my passwd
 * 
 * I didn't really understand why I had 0 with the OR and AND
 * operations, but I solved the problem now !
 */
               switch (bit_operations[j]) {         
	        case 0:
                            nb = (tempa ^ tempb);
                            break;
                case 1:
                            nb = (unsigned int) (~(tempa | tempb))%2;
                            break;
                default:
                            nb = (unsigned int) (~(tempa & tempb))%2;
                            break;
               }

              /*
               * (1 << indexa) put the number 1 on the bit located
               * at the same place of the bit that will be changed.
               * Then we take his complementary and we do a LOGICAL AND
               * that will put this number to 0, whatever was is
               * previous value (0 or 1) because we always do
               * LOGICAL AND with a 0.
               * Because all the over bits are set to 1, they
               * will not change the value of the other bits
               * in the aray.
               */

              *a &= ~(1 << indexa);

             /*
              * We put the bit that we want to change in the new
              * position where we want it to be.
              * We do a LOGICAL OR to put it in the new
              * position.
              * Indeed, because we put in the previous
              * operation the bit to 0 :
              * 0 | 0 = 0
              * 1 | 0 = 1
              */                            

              *a |= (nb << indexa);

	   i++;
	   z++;
	
        }
	  while (i < varinit->KEYLENGTH);

/*
 * That should be useless, but in case of a 0 is in the
 * passwd, it is better to change this value.
 */
for (i = 0; i < varinit->NB_INDEX; i++)
    {
     if (pass_code[i] == 0)
	 {
	  pass_code[i] = 0 - (170 * bpow(256,(varinit->NB_BYTE - 1)));
          if (mode == 1)
		printf("\n WARNING : 0 detected and changed");
         }
    }

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n Bcrypt_swap function finished.");
    fflush(BCRYPTLOG);
   }

return 1;
	
}


/*
 * CODE FUNCTION
 *
 *  To make this crypt algorithm more efficient, I realised this last part
 *
 *      I add a random number to each number of my passwd.
 *      this random number is initialised in the begining of my function.
 *       
 *      I know, there is no real random function on a computer,
 *      but I think that wont make my algorithm weak.
 *      If someone can prove that to me, then I will implement 
 *      a more efficient random function.
 *
 *      I shift all the bit of the random number by 1 on the left each
 *      time that I use it to do an addition.
 *      And the bit the more on the left that should diseapear after the 
 *      shift, I put it on the right. 
 *
 *      That's a circle shift random number
 *
 *      eg. :
 *      Random number X = 81 and the number that I want to code are 1,2,3
 *      
 *      X=81 -> 01010001
 *      01010001 = 81
 *      10100010 = 162
 *      01000101 = 69
 *       1+81 = 82 , 2+162 = 164 , 3+69= 72
 *
 *  In fact is not that simple, I do not shift all the bit by one each time,
 *  because it will be useless, so I do a shift with a number each time
 *  different that depend of the clear text.
 *
 *      Thanks to the random number even if you type the same passwd in input
 *      you can have  2^31  different cipher text ...
 *      (if I use a long random number = 4 bytes = 32 bits)
 *      ATTENTION : On linux OS, int = 4 BYTES
 */
int bcrypt_code
  (int choice, TYPE_INT random_key, TYPE_INT *pass_code,
   unsigned char *pass_clear, int mode, globalvar *varinit)
{
  unsigned int i, bits, clock;
  TYPE_INT randvar, nb, tempvar, length_int = 0;

 if (mode == 1)
    {
    fprintf(BCRYPTLOG, "\n\n Code function started.");
    fflush(BCRYPTLOG);
    }
/*
 * rand() function return an unsigned int value
 * I take the bit length of it
 */
  bits = varinit->NB_BYTE * 8;

/*
 * To know what is the bigest int possible, I have to change th evalue of his
 * bits to 1 except the sign bit.
 */
for (i = 0; i < (bits - 2); i++)
   {
    length_int |= 1;
    length_int = (length_int << 1);
  }

/*
 * choice = 0 = I want to crypt
 * choice = 1 = I want to crypt with a specific random key
 */
  if (choice == 0)
    {
/*
 * I take the time
 */
      clock = (int) time (NULL);

/* 
 * I initialise the random sequence on the time
 */
      srand (clock);	

/*
 * If the bit's length of the value returned by the rand() function is
 * smaller than the bit's length of TYPE_INT then the random number
 * maybe weak.
 * It is why I do 3 multiplications to be able to obtain a big random number
 */
      randvar = (unsigned int) (rand() * rand() * rand()) % length_int;
      random_key = randvar;
    }        
  else
    randvar = random_key;

pass_code[0] = (pass_code[0] ^ randvar);

  for (i = 1; i < varinit->NB_INDEX; i++)
    {
      tempvar = (randvar >> (bits - ((unsigned int)pass_clear[i] % bits)));
      
      nb = 0;
      nb |= (randvar << ((unsigned int)pass_clear[i] % bits) );

      nb |= tempvar;

      randvar = nb;

      pass_code[i] = (pass_code[i] ^ nb);
    }


/*
 * That should be useless, but in case of a 0 is in the
 * passwd, it is better to change this value.
 */
for (i = 0; i < varinit->NB_INDEX; i++)
    {
     if (pass_code[i] == 0)
	 {
	  pass_code[i] = 0 - (170 * bpow(256,(varinit->NB_BYTE - 1)));
          if (mode == 1)
		printf("\n WARNING : 0 detected and changed");
         }
    }

if (mode == 1)
   {
     fprintf(BCRYPTLOG, "\n Code function finished.");
     fflush(BCRYPTLOG);
   }
return 1;
}


/*
 * TEST PASSWD FUNCTION
 * test if the passwd is right
 */
int
bcrypt_test_passwd (int power, TYPE_INT *code_file, unsigned char *pass_clear,
                    int length, int mode, globalvar *varinit)
{
  TYPE_INT *pass_code, *swap_length;
  TYPE_INT bit_operations[3];

/*
 * On linux OS, rand() return an unsigned int
 */
  unsigned int random_key;

/*
 * pass_code will receive the numerical value of the characters
 * swap_length will receive the different lengths of the different swaps
 */
pass_code = (TYPE_INT *) malloc (varinit->NB_CHAR);
swap_length = (TYPE_INT *) malloc (varinit->NB_CHAR_DOUBLE);


  if (bcrypt_test_length (pass_clear, length, mode, varinit) == 0)
     return 0;

  if (bcrypt_transcription (pass_clear, pass_code, swap_length,
      bit_operations, mode, varinit) == 0)
    return 0;

  if (bcrypt_add (pass_code, swap_length, mode, varinit) == 0)
    return 0;

  if (bcrypt_swap (swap_length, pass_code, bit_operations,
                                                   mode, varinit) == 0)
     return 0;

  random_key = bcrypt_read_key (pass_code, code_file, mode, varinit);

  if (bcrypt_code (1, random_key, pass_code, pass_clear, mode, varinit) == 0)
      return 0;

  return bcrypt_comparison(code_file, pass_code, mode, varinit);
}


/*
 * READ PASSWD FUNCTION
 * find the old passwd to allow the algorithm to compare it later
 */
int bcrypt_read_passwd
  (char *user, char *file_path, TYPE_INT *code_file, int mode,
					           globalvar *varinit)
{

  int i;
  FILE *file_name;

 typedef struct
         {
                char *name;
                TYPE_INT *pass;
         }
  enreg;

  enreg *var;

 var = (enreg *) malloc (varinit->USER_LENGTH + varinit->NB_CHAR);
 var->name = (char *) malloc(varinit->USER_LENGTH);
 var->pass = (TYPE_INT *) malloc(varinit->NB_CHAR);

 if (mode == 1)
     {
     fprintf(BCRYPTLOG, "\n\n Read passwd function started.");
     fflush(BCRYPTLOG);
     }
  file_name = fopen (file_path, "rb");
  if (file_name == NULL)
   {
    return 0;
    }

  fseek (file_name, 0, 0);

  do
    {
      do
	{
	  fread (var->name, varinit->USER_LENGTH, 1, file_name);
          fread (var->pass, varinit->NB_CHAR, 1, file_name);
	}
      while ((feof (file_name) == 0) &&
                    (strncmp (user, var->name, strlen (user)) != 0));
    }
/*
 * That avoid the confusion between two login like :
 *  bugs and bugsophile
 * If we did not do the following comparison, these 2 logins
 * would have been equal.
 */
  while ((feof (file_name) == 0) && (strlen (var->name) != strlen (user)));


  if ((strncmp (user, var->name, strlen (user)) != 0) || 
				(strlen (var->name) != strlen (user)))
    {
      fclose (file_name);
      return 0;
    }

fclose(file_name);

if (mode == 1)
    {
    fprintf(BCRYPTLOG, "\n User '%s' found in the file '%s'.", user, file_path);
    fflush(BCRYPTLOG);
    }
  /*
   * We take the user passwd
   */

  for (i = 0; i < (varinit->NB_CHAR / varinit->NB_BYTE); i++)
    code_file[i] = var->pass[i];

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Read passwd funtion Finished.");
   fflush(BCRYPTLOG);
   }
  return 1;
}


/*
 * READ KEY FUNCTION
 * Use to find the random number used when the algorithm first
 * crypted the passwd.   
 */
TYPE_INT bcrypt_read_key
  (TYPE_INT *pass_code, TYPE_INT *code_file, int mode, globalvar *varinit)
{
  TYPE_INT random_key;

  if (mode == 1)
     {
     fprintf(BCRYPTLOG, "\n\n Read key function Started.");
     fflush(BCRYPTLOG);
     }
    random_key = code_file[0] ^ pass_code[0];

  if (mode == 1)
     {
     fprintf(BCRYPTLOG, "\n Read key function Finished.");
     fflush(BCRYPTLOG);
     }
  return random_key;
}


/*
 * COMPARISON FUNCTION
 * Compare the passwd give by the user with the passwd archived
 */
int
bcrypt_comparison (TYPE_INT *code_file, TYPE_INT *pass_code, int mode,
                   globalvar *varinit)
 {
  int i = 0;
  

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n\n Comparison funtion Started.");
   fflush(BCRYPTLOG);
   }
  while ((code_file[i] == pass_code[i]) && (i < varinit->NB_INDEX))
    {
      i++;
    }


if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n Comparison funtion Finished.");
    fflush(BCRYPTLOG);
   } 
  if ((i == varinit->NB_INDEX) &&
      (code_file[varinit->NB_INDEX - 1] == pass_code[varinit->NB_INDEX - 1]))
    return 1;

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Comparison function failed.");
   fflush(BCRYPTLOG);
   }
  return 0;
}

/*
 * POWER = 0
 *
 * FILE CRYPT FUNCTION
 *
 *		Crypt a file X in a file Y
 *
 * I define an aray A of n integer,
 * where n * varinit->NB_INDEX * varinit->NB_BYTE = X file's length
 * (The truth is not out there, but in this algorithm ... ;o)
 * Then I will be able to add a filter that is a cipher text of
 * varinit->NB_INDEX*varinit->NB_BYTE
 * bytes in the X file, the position of this filter is function of the 
 * passwd typed by the user.
 * I change the aray A to be sure to do not add a filter at the same 
 * position again.
 * When all the aray A has been filled, that means that all the X file has
 * been crypted.
 * 
 * IMPORTANT NOTE:
 * the first filter is the cypher text C1 of the passwd typed by the user,
 * AND THE SECOND FILTER is the cypher text of C1.
 * Indeed, I use C1 like a new passwd, and to crypt another part of my 
 * X file I will use C2 to generate C3, etc ... 
 */
int
bcrypt_write_file (FILE *file_clear, FILE *file_code, int *fich_tab, 
    int length_tab, TYPE_INT *pass_code, TYPE_INT *swap_length,
    TYPE_INT *bit_operations, int mode, globalvar *varinit)
{

int x, i, j, pos, nb_code, file_length;
int rest_byte;
unsigned char *pass_clear;
TYPE_INT *carac, *file_tempvar;

int l,k,shift;

pass_clear = (unsigned char *) malloc (varinit->NB_CHAR);
file_tempvar = (TYPE_INT *) malloc (varinit->NB_CHAR);
carac = (TYPE_INT *) malloc (varinit->NB_BYTE);

for (i = 0; i < varinit->NB_INDEX; i++) file_tempvar[i] = 0;

nb_code = 0;

  j = 1;
  x = 0;

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n\n Crypt write file function Started.");
   fflush(BCRYPTLOG);
   }
       
fseek (file_clear, 0, 2);
file_length = ftell (file_clear);

  do
    {
      /*
       *  We find where we are going to insert the filter 
       */
      if (swap_length[varinit->NB_INDEX_DOUBLE - j] < 0)
	x = x - swap_length[varinit->NB_INDEX_DOUBLE - j];
      else
	x = x + swap_length[varinit->NB_INDEX_DOUBLE - j];

      x = x  % length_tab;

      if (x < 0) x = 0 - x;

      j++;

      if (j == varinit->NB_INDEX_DOUBLE)
         j = 1;
        
      pos = x;


   	  while (fich_tab[pos] == 1)
	    {
	      pos = (pos + 1) % length_tab;
	    }

      pos = pos * varinit->NB_CHAR;

 if ( (pos + varinit->NB_CHAR) <= file_length)
     {

    /*
     * we go to the position 'pos' in the file to crypt
     */
    fseek (file_clear, pos, 0);

    /*
     * We save the file data to crypt in file_tempvar
     * We read (varinit->NB_BYTE * varinit->NB_INDEX) bytes from the clear
     * file
     */
      fread (file_tempvar, varinit->NB_BYTE, varinit->NB_INDEX, file_clear);

    /*
     * We go the the same position in the file that will
     * receive the crypted data
     */
      fseek (file_code, pos, 0);

      for (i = 0; i < varinit->NB_INDEX; i++)
	{
	  *carac = (pass_code[i] ^ file_tempvar[i]);

	  fwrite (carac, varinit->NB_BYTE, 1, file_code);
	}

      }
else
    {
      rest_byte = (file_length - pos);

    if (mode == 1)
       {
       fprintf(BCRYPTLOG, "\n End of File's number of bytes to crypt : %d.",
                                                              rest_byte);
       fflush(BCRYPTLOG);
       }
    /*
     * we go to the position 'pos' in the file to crypt
     */
      fseek (file_clear, pos, 0);

    /*
     * We save the file data to crypt in file_tempvar
     * We read '1 * rest_byte' bytes from the clear file
     */
      fread (file_tempvar, rest_byte, 1, file_clear);

    /*
     * We go the the same position in the file that will
     * receive the crypted data
     */
      fseek (file_code, pos, 0);

	i = 0;
          do
            {
	      *carac = (pass_code[i] ^ file_tempvar[i]);

             if (varinit->NB_BYTE <= rest_byte)
	       {
                fwrite (carac, 1, varinit->NB_BYTE, file_code);
	        rest_byte = rest_byte - varinit->NB_BYTE;
               }
             else
		{
		fwrite(carac, 1, rest_byte, file_code);
		rest_byte = 0;
 		}

              i++;
	    } while ( rest_byte > 0 );

	}

      fich_tab[(pos / varinit->NB_CHAR)] = 1;
      nb_code++;

      /*
       * The cipher text becomes the new 'typed' passwd
       */


/*
 * this function seems to have problems to put some long integer
 * in a string ...
 strncpy(pass_clear,pass_code,varinit->NB_CHAR);
 * that is why I have done the following function.
*/


/*
 * We translate the long integer from pass_code into some characters
 * in the string pass_clear
 */
l=0;
k=0;
i=0;
    do
     {
       if (l == 0) shift = 24;
         else
       shift = shift - 8; 
 
       pass_clear[i] = (int)((pass_code[k] << shift) >> 24)%256;
       
       l++;
       if (l == varinit->NB_BYTE) 
          {
           l = 0;
           k++;
          }
        i++;
     
       }
      while (k < varinit->NB_INDEX);

      if (bcrypt_transcription (pass_clear, pass_code, swap_length,
           bit_operations, mode, varinit) == 0)
	return 0;

      if (bcrypt_add (pass_code, swap_length, mode, varinit) == 0)
          return 0;

      if  (bcrypt_swap (swap_length, pass_code, bit_operations, mode,
                                                           varinit) == 0)
           return 0;


    }
  while (nb_code < (length_tab));

if (mode == 1)
   {
   fprintf(BCRYPTLOG,"\n Crypt write file function Finished.");
   fflush(BCRYPTLOG);
   }
   
  fclose(file_clear);
  fclose(file_code);

  return 1;
}


/*
 * POWER = 1
 * 
 * PROBABILITY FILE CRYPT FUNCTION
 *
 * This function is quite similar to the standard one.
 *
 * The difference is that I use a random number to generate my filter.
 * I generate ONE random number, I crypt it and save it in a pseudo
 * random place in the file, and I use this random number in the passwd
 * generation.
 *
 * Like that for ONE passwd and ONE clear text I have MANY cipher text
 *
 * To do that I had to add in the crypted file some data, the length
 * of them is equal to the key length used.
 * 
 * this algorithm is MUCH STRONGER than the standard one,
 * indeed if someone try to uncrypt a cipher file, he will never be
 * sure that he found the good clear file.
 */
int 
bcrypt_write_file_prob (int choice, FILE *file_clear, FILE *file_code,
    int *fich_tab, int length_tab, TYPE_INT *pass_code,
    unsigned char *pass_clear, TYPE_INT *code_key, TYPE_INT *swap_length,
    TYPE_INT *bit_operations, int mode, globalvar *varinit)
{

int x, i, j, pos, nb_code, file_length;
int rest_byte;
TYPE_INT *carac, *file_tempvar, length_int = 0;

int l,k,shift, poskey;
TYPE_INT random_key;

file_tempvar = (TYPE_INT *) malloc (varinit->NB_CHAR);
carac = (TYPE_INT *) malloc (varinit->NB_BYTE);

for (i = 0; i < ((varinit->NB_BYTE * 8) - 2); i++)
   {
    length_int |= 1;
    length_int = (length_int << 1);
  }

for (i = 0; i < varinit->NB_INDEX; i++) file_tempvar[i] = 0;

nb_code = 0;
poskey = 0;


if (mode == 1)
 {
 fprintf(BCRYPTLOG, "\n\n Probability crypt write file function Started.");
 fflush(BCRYPTLOG);
 }

fseek (file_clear, 0, 2);
file_length = ftell (file_clear);


if (choice == 0)
file_length = file_length + varinit->NB_CHAR;

      /*
       *  We find where we are going to insert the Random key
       */
      if (swap_length[0] < 0)
	poskey = poskey - swap_length[0];
      else
	poskey = swap_length[0];

      poskey = poskey  % (length_tab - 1);

      if (poskey < 0) poskey = 0 - pos;

      poskey = poskey * varinit->NB_CHAR;

    /*
     * we go to the position 'pos' in the file to crypt
     */
    fseek (file_clear, poskey, 0);

    /*
     * We go the the same position in the file that will
     * receive the crypted data
     */
      fseek (file_code, poskey, 0);

     if (choice == 0)
        {
         for (i = 0; i < varinit->NB_INDEX; i++)
	     {
	      *carac = (pass_code[i] ^ code_key[i]);
              fwrite (carac, varinit->NB_BYTE, 1, file_code);
	     }
         }
      else
         {
          fread (file_tempvar, varinit->NB_BYTE, varinit->NB_INDEX,
							    file_clear);
          for (i = 0; i < varinit->NB_INDEX; i++)
	     {
	      *carac = (pass_code[i] ^ file_tempvar[i]);
              code_key[i] = *carac;
	     }
          }
  
      fich_tab[(poskey / varinit->NB_CHAR)] = 1;
      nb_code++;

      random_key = 1;
      
      for (i = 0; i< varinit->NB_INDEX; i++)
         random_key = (random_key * code_key[i]) % length_int; 

      if (random_key < 0) random_key = 0 - random_key;

      /*
       * Now, I generate again the first cipher text, but I add a 
       * random number
       */
      if (bcrypt_code (1, random_key, pass_code, pass_clear,
						 mode, varinit) == 0)
         return 0;


    j = 1;
    x = 0;

  do
    {

      /* 
       *  We find where we are going to insert the filter 
       */
      if (swap_length[varinit->NB_INDEX_DOUBLE - j] < 0)
	x = x - swap_length[varinit->NB_INDEX_DOUBLE - j];
      else
	x = x + swap_length[varinit->NB_INDEX_DOUBLE - j];

      x = x  % length_tab;

      if (x < 0) x = 0 - x;

      j++;

      if (j == varinit->NB_INDEX_DOUBLE)
         j = 1;
        
      pos = x;

   	  while (fich_tab[pos] == 1)
	    {
	      pos = (pos + 1) % length_tab;
	    }

      pos = pos * varinit->NB_CHAR;

 if ( (pos + varinit->NB_CHAR) <= file_length)
     {             
    /*
     * we go to the position 'pos' in the file to crypt or in the file
     * to uncrypt if choice = 0
     */

    if ((choice ==  0) && (pos > poskey))
       fseek(file_clear, (pos - varinit->NB_CHAR), 0);
     else 
    fseek (file_clear, pos, 0);

    /*
     * We save the file data to crypt in file_tempvar
     * We read (varinit->NB_BYTE * varinit->NB_INDEX) bytes from
     * the clear file
     */
      fread (file_tempvar, varinit->NB_BYTE, varinit->NB_INDEX, file_clear);

    /*
     * We go the the same position in the file that will
     * receive the crypted data or the clear text if choice = 0
     */
      if ((choice != 0) && (pos > poskey))
          fseek(file_code, (pos - varinit->NB_CHAR), 0);
      else
          fseek(file_code, pos, 0);

      for (i = 0; i < varinit->NB_INDEX; i++)
	{
	  *carac = (pass_code[i] ^ file_tempvar[i]);
	  fwrite (carac, varinit->NB_BYTE, 1, file_code);
	}

      }
else
    {
      rest_byte = (file_length - pos);
   
    if (mode == 1) 
     {
     fprintf(BCRYPTLOG, "\n End of File's number of bytes to crypt : %d.",
                                                              rest_byte);
     fflush(BCRYPTLOG);
     }
    /*
     * we go to the position 'pos' in the file to crypt
     */
      if ((choice ==  0) && (pos > poskey))
       fseek(file_clear, (pos - varinit->NB_CHAR), 0);
     else 
       fseek (file_clear, pos, 0);

    /*
     * We save the file data to crypt in file_tempvar
     * We read '1 * rest_byte' bytes from the clear file
     */
      fread (file_tempvar, 1, rest_byte, file_clear);

    /*
     * We go the the same position in the file that will
     * receive the crypted data
     */
      if ((choice != 0) && (pos > poskey))
          fseek(file_code, (pos - varinit->NB_CHAR), 0);
      else
          fseek(file_code, pos, 0);

              
 	i = 0;
          do
            {
	      *carac = (pass_code[i] ^ file_tempvar[i]);
	      
             if (varinit->NB_BYTE <= rest_byte)
	       {
                fwrite (carac, 1, varinit->NB_BYTE, file_code);
	        rest_byte = rest_byte - varinit->NB_BYTE;
               }
             else
		{
		fwrite(carac, 1, rest_byte, file_code);
		rest_byte = 0;
 		}
	   
              i++;
	    } while ( rest_byte > 0 );


	}

       fich_tab[(pos / varinit->NB_CHAR)] = 1;

      nb_code++;

      /*
       * The cipher text becomes the new 'typed' passwd
       */ 


/*
 * We translate the long integer from pass_code into some characters
 * in the string pass_clear
 */
l=0;
k=0;
i=0;
    do  
     {
       if (l == 0) shift = 24;
         else
       shift = shift - 8; 
 
       pass_clear[i] = (int)((pass_code[k] << shift) >> 24)%256;
       
       l++;
       if (l == varinit->NB_BYTE)
          {
           l = 0;
           k++;
          }
        i++;
     
       }
      while (k < varinit->NB_INDEX);

      if (bcrypt_transcription (pass_clear, pass_code, swap_length,
           bit_operations, mode, varinit) == 0)
	return 0;

      if (bcrypt_add (pass_code, swap_length, mode, varinit) == 0)
          return 0;

      if  (bcrypt_swap (swap_length, pass_code, bit_operations,
						 mode, varinit) == 0)
           return 0;

      if (bcrypt_code (1, random_key, pass_code, pass_clear,
						 mode, varinit) == 0)
         return 0;

    }
  while (nb_code < length_tab);

if (mode == 1)
 {
 fprintf(BCRYPTLOG,"\n Probability Crypt write file function Finished.");
 fflush(BCRYPTLOG);
 }
  fclose(file_clear);
  fclose(file_code);

  return 1;

}


/*  
 * WRITE PASSWD FUNCTION
 * Write the cipher text in a file (like /etc/passwd)
 */
int 
bcrypt_write_passwd (char *user, TYPE_INT *pass_code, char *file_path,
                     int mode, globalvar *varinit)
{
  FILE *file_name;
  fpos_t pos;
  int i;

 typedef struct
         {
                char *name;
                TYPE_INT *pass;
         }
  enreg;

  enreg *var;

 var = (enreg *) malloc (varinit->USER_LENGTH + varinit->NB_CHAR);
 var->name = (char *) malloc(varinit->USER_LENGTH);
 var->pass = (TYPE_INT *) malloc (varinit->NB_CHAR);

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n\n Write passwd function started.");
    fprintf(BCRYPTLOG,"\n Passwd archive file name : %s.",file_path);
    fflush(BCRYPTLOG);
   }

  file_name = fopen (file_path, "r+b");

  if (file_name != NULL)
    {
      fseek (file_name, 0, 0);

      do
	{
	  do
	    {
	      fgetpos (file_name, &pos);
	      fread (var->name, varinit->USER_LENGTH, 1, file_name);
              fread (var->pass, varinit->NB_CHAR, 1, file_name);
	    }
	  while ((feof (file_name) == 0) &&
                     (strncmp (var->name, user, strlen (user)) != 0));
	}
      while ((feof (file_name) == 0) &&
                            (strlen (var->name) != strlen (user)));

      if (strncmp (var->name, user, strlen (user)) == 0)
	fsetpos (file_name, &pos);
    }
  else
    {
      fclose(file_name);
      file_name = fopen (file_path, "wb");
    }
  strncpy (var->name, user, varinit->USER_LENGTH);
  for (i = 0; i < varinit->NB_INDEX; i++)
    var->pass[i] = pass_code[i];

  fwrite (var->name, varinit->USER_LENGTH, 1, file_name);
  fwrite (var->pass, varinit->NB_CHAR, 1, file_name);

  fclose (file_name);

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Write passwd file function finished.");
   fflush(BCRYPTLOG);
   }
  return 1;
}



/*
 * WRITE KEY FUNCTION
 * Write the key in a file (like /etc/key)
 */
int 
bcrypt_write_keyfile (unsigned char *pass_clear, char *file_path, int mode,
					 globalvar *varinit)
{
  FILE *file_name;

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n\n Write key function started.");
    fprintf(BCRYPTLOG,"\n Key archive file name : %s.",file_path);
    fflush(BCRYPTLOG);
   }

   file_name = fopen (file_path, "wb");

  fwrite (pass_clear, varinit->NB_CHAR, 1, file_name);

  fclose (file_name);

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Write key file function finished.");
   fflush(BCRYPTLOG);
   }
fclose(BCRYPTLOG);
  return 1;
}


/*
 * READ KEY FUNCTION
 * Read the key from  file (like /etc/key)
 */
int
bcrypt_read_keyfile (unsigned char *pass_clear, char *file_path, int mode,
					 globalvar *varinit)
{
  FILE *file_name;
  int file_length;
if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n\n Read key function started.");
    fprintf(BCRYPTLOG,"\n Key archive file name : %s.",file_path);
    fflush(BCRYPTLOG);
   }

   file_name = fopen (file_path, "rb");

   fseek(file_name,0,2);
   file_length = ftell(file_name);
   if (file_length < varinit->NB_CHAR)
      {
	fclose(file_name);
	return 0;
      }

/*
 * If the file's length is > to the keylength
 * then I will take the data in the middle of the file.
 * It is more secure, in case of the file has always the same header
 * and footer.
 * If the file's length is <= to the keylength
 * That is not worth it, and the key file SHOULD have been generated
 * with bcrypt_key_generator !
 */
    if (file_length > (varinit->NB_CHAR * 2))
        fseek(file_name,(file_length / 2),0);
    else
        fseek(file_name,0,0);

  fread (pass_clear, varinit->NB_CHAR, 1, file_name);
  fclose (file_name);

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Read key file function finished.");
   fflush(BCRYPTLOG);
   }
  return 1;
}

/*
 * WRITE HIDE FUNCTION
 * Put some data in afile
 * choice = 0 -> at the begining of the file
 * choice = 1 -> at the end of the file
 */
RETURN_TYPE
bcrypt_write_hide (int choice, char *source_file, char *dest_file,
				                          int mode)
{
  FILE *file_s, *file_d, *file_old;
  TYPE_INT file_s_length, file_d_length;
  int i;
  char *carac, *name;

  carac = (char *) malloc(1);

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n\n Write hide function started.");
    fprintf(BCRYPTLOG,"\n Source file name : %s.",source_file);
    fprintf(BCRYPTLOG,"\n Destination file name : %s.",dest_file);
    if (choice == 0)
	fprintf(BCRYPTLOG, "\n Write data at the : BEGINING");
    else
	fprintf(BCRYPTLOG, "\n Write data at the : END");
    fflush(BCRYPTLOG);
   }

name = (char *) malloc(strlen(dest_file) + 4);
i = 0;
do
 {
   name[i] = dest_file[i];
   i++;
 } while( (i<strlen(dest_file)) && (dest_file[i] != '.') );

strcat(name,".old");

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Backup destination file in '%s'.",name);
   fflush(BCRYPTLOG);
   }
   
   file_s = fopen (source_file, "rb");
   file_d = fopen (dest_file, "r+b");
   file_old = fopen (name, "w+b");

if (file_s == NULL || file_d == NULL || file_old == NULL)
   {
    fclose(file_s);
    fclose(file_d);
    fclose(file_old);
    fclose(BCRYPTLOG);
    return 0;
   }

   fseek(file_d,0,2);
   fseek(file_s,0,2);

   file_d_length = ftell(file_d);
   file_s_length = ftell(file_s);

   fseek(file_d,0,0);
   fseek(file_s,0,0);
   fseek(file_old,0,0);

if (mode == 1)
   {
   fprintf(BCRYPTLOG,"\n Backup destination file in progress.");
   fflush(BCRYPTLOG);
   }
  for (i = 0; i < file_d_length; i++)
      {
       fread(carac, 1, 1, file_d);
       fwrite(carac, 1, 1, file_old);
      }

if (mode == 1)
    {
    fprintf(BCRYPTLOG,"\n Backup finished.");
    fflush(BCRYPTLOG);
    }
   fseek(file_d,0,0);
   fseek(file_old,0,0);

   if (choice == 0)
	{
	 if (mode == 1)
	    {
        fprintf(BCRYPTLOG,"\n Writing data at the begining of the file.");
        fflush(BCRYPTLOG);
        }
	fwrite(&file_s_length, sizeof(TYPE_INT), 1, file_old);

	 for (i = 0; i < file_s_length; i++)
	     {
		 fread(carac, 1, 1, file_s);
	   	 fwrite(carac, 1, 1, file_d);
	     }
        }

   if (mode == 1)
      {
      fprintf(BCRYPTLOG, "\n Writing destination data.");
      fflush(BCRYPTLOG);
      }
   for (i = 0; i < file_d_length; i++)
       {
	fread(carac,1,1,file_old);
	fwrite(carac,1,1,file_d);
       }

   if (choice == 1)
      {
       if (mode == 1)
	    {
        fprintf(BCRYPTLOG,"\n Writing data at the end of the file");
        fflush(BCRYPTLOG);
        }
       for (i = 0; i < file_s_length; i++)
           {
            fread(carac,1,1,file_s);
            fwrite(carac,1,1,file_d);
           }

   	  fwrite(&file_s_length, sizeof(TYPE_INT), 1, file_d);

      }

   fclose(file_s);
   fclose(file_d);
   fclose(file_old);


if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Write hide function finished.");
   fflush(BCRYPTLOG);
   }
fclose(BCRYPTLOG);
  return 1;
}


/*
 * READ HIDE FUNCTION
 * Put some data in afile
 * choice = 0 -> at the begining of the file
 * choice = 1 -> at the end of the file
 */
RETURN_TYPE 
bcrypt_read_hide (int choice, char *source_file, char *dest_file,
				                          int mode)
{
  FILE *file_s, *file_d;
  TYPE_INT file_s_length, file_d_length;
  int i;
  char *carac;
  
  carac = (char *) malloc(1);

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n\n Read hide function started.");
    fprintf(BCRYPTLOG,"\n Source file name : %s.",source_file);
    fprintf(BCRYPTLOG,"\n Destination file name : %s.",dest_file);
    if (choice == 0)
	fprintf(BCRYPTLOG, "\n Read data from the : BEGINING");
    else
	fprintf(BCRYPTLOG, "\n Read data from the : END");
    fflush(BCRYPTLOG);
   }

   file_s = fopen (source_file, "rb");
   file_d = fopen (dest_file, "rb");

if (file_d != NULL)
{
fclose(BCRYPTLOG);
 return 0;
 }

   file_d = fopen(dest_file, "wb");

if (file_s == NULL || file_d == NULL)
   {
    fclose(file_s);
    fclose(file_d);
    fclose(BCRYPTLOG);
    return 0;
   }

   fseek(file_s,0,2);

   file_s_length = ftell(file_s);

   fseek(file_d,0,0);
   fseek(file_s,0,0);

   if (choice == 0)
	{
	 if (mode == 1)
        {
    fprintf(BCRYPTLOG,"\n Extracting hide data from the begining of the file.");
    fflush(BCRYPTLOG);
    }

  	 fread(&file_d_length, sizeof(TYPE_INT), 1, file_s);

         if (file_d_length > file_s_length)
         {
          fclose(BCRYPTLOG);
          return 0;
          }

	 for (i = 0; i < file_d_length; i++)
	     {
		 fread(carac, 1, 1, file_s);
	   	 fwrite(carac, 1, 1, file_d);
	     }
        }
      else
      {
       if (mode == 1)
	  {
      fprintf(BCRYPTLOG,"\n Extracting Hide data from the end of the file");
      fflush(BCRYPTLOG);
      }
       fseek(file_s, -(sizeof(TYPE_INT)), 2);

       fread(&file_d_length, sizeof(TYPE_INT), 1, file_s);

       if (file_d_length > file_s_length)
       {
       fclose(BCRYPTLOG);
        return 0;
        }

	fseek(file_s, -(file_d_length + sizeof(TYPE_INT)), 2);

       for (i = 0; i < file_d_length; i++)
           {
            fread(carac,1,1,file_s);
            fwrite(carac,1,1,file_d);
           }

      }

   fclose(file_s);
   fclose(file_d);

if (mode == 1)
{
fprintf(BCRYPTLOG, "\n Hide function finished.");
fflush(BCRYPTLOG);
}
fclose(BCRYPTLOG);
  return 1;
}


/*
 * DELETE PASSWD FUNCTION
 * 
 * Delete a user from a password file
 */
int
bcrypt_delete_passwd (char *pass_file, char *user, int keylength,
 				          int mode, globalvar *varinit)
{
  FILE *file_s, *file_old;
  fpos_t pos, pos_old;
  char *carac;

 typedef struct
         {
                char *name;
                TYPE_INT *pass;
         }
  enreg;

  enreg *var;

 var = (enreg *) malloc (varinit->USER_LENGTH + varinit->NB_CHAR);
 var->name = (char *) malloc(varinit->USER_LENGTH);
 var->pass = (TYPE_INT *) malloc (varinit->NB_CHAR);

carac = (char *) malloc(1);

if (mode == 1)
   {
    fprintf(BCRYPTLOG, "\n\n Delete passwd function started.");
    fprintf(BCRYPTLOG,"\n Passwd file name : %s.",pass_file);
    fprintf(BCRYPTLOG,"\n User name : %s.",user);
    fprintf(BCRYPTLOG,"\n KEYLENGTH : %d",keylength);
    fprintf(BCRYPTLOG,"\n Old passwd file : pass.old");
    fflush(BCRYPTLOG);
   }

file_s = fopen (pass_file, "rb");

if (file_s == NULL)
   {
    fclose(file_s);
    fclose(BCRYPTLOG);
    return 0;
   }

   if (mode == 1)
      {
      fprintf(BCRYPTLOG, "\n Locating user.");
      fflush(BCRYPTLOG);
      }
   do
    {
      do
	{
          fgetpos (file_s, &pos);
	  fread (var->name, varinit->USER_LENGTH, 1, file_s);
          fread (var->pass, varinit->NB_CHAR, 1, file_s);
     	}
      while ((feof (file_s) == 0) &&
                (strncmp (user, var->name, strlen (user)) != 0));
    }
/*
 * That avoid the confusion between two login like :
 *  bugs and bugsophile
 * If we did not do the following comparison, these 2 logins
 * would have been equal.
 */
  while ((feof (file_s) == 0) && (strlen (var->name) != strlen (user)));


  if ((feof (file_s) != 0) &&
             (strncmp (user, var->name, strlen (user)) != 0))
    {
      fclose (file_s);
      return 0;
    }

if (mode == 1)
 {
 fprintf(BCRYPTLOG, "\n User '%s' found in the file '%s'.", user, pass_file);
 fflush(BCRYPTLOG);
 }
  /*
   * We delete the user passwd
   */
file_old = fopen ("pass.old", "wb");
fseek (file_s, 0, 0);
fseek (file_old, 0, 0);

 if (mode == 1)
    {
    fprintf(BCRYPTLOG,"\n Saving password file in 'pass.old'.");
    fflush(BCRYPTLOG);
    }
    
 fread(carac, 1, 1, file_s);

	  do
	     {
	   	 fwrite(carac, 1, 1, file_old);
		 fread(carac, 1, 1, file_s);
	     }
          while(feof(file_s) == 0);

/*
 * I have to close the file if I want to put the EOF flag
 */
  fclose(file_old);
  fclose(file_s);
  if(remove(pass_file) != 0)
  {
   return 0;
   }
  file_s = fopen(pass_file,"wb");
  file_old = fopen("pass.old","rb");

  if (file_s == NULL || file_old == NULL)
    {
    return 0;
    }

fseek (file_old, 0, 0);

fgetpos(file_old, &pos_old);

while (pos_old < pos)
   {
     fread (var->name, varinit->USER_LENGTH, 1, file_old);
     fread (var->pass, varinit->NB_CHAR, 1, file_old);
     fwrite(var->name, varinit->USER_LENGTH, 1, file_s);
     fwrite(var->pass, varinit->NB_CHAR, 1, file_s);
     fgetpos (file_old, &pos_old);
   }

pos_old = pos_old + varinit->USER_LENGTH + varinit->NB_CHAR;
fsetpos(file_old, &pos_old);

fread (var->name, varinit->USER_LENGTH, 1, file_old);
fread (var->pass, varinit->NB_CHAR, 1, file_old);

while(feof(file_old) == 0)
   {
     fwrite(var->name, varinit->USER_LENGTH, 1, file_s);
     fwrite(var->pass, varinit->NB_CHAR, 1, file_s);
     fread (var->name, varinit->USER_LENGTH, 1, file_old);
     fread (var->pass, varinit->NB_CHAR, 1, file_old);
   }

fclose(file_s);
fclose(file_old);

if (mode == 1)
   {
   fprintf(BCRYPTLOG, "\n Delete passwd funtion Finished.");
   fflush(BCRYPTLOG);
  }
  return 1;
}


/*
 * POWER FUNCTION
 * calcul a power of 2 for example
 * The one on Linux didn't return what exactly I wanted,
 * so I did mine.
 */
RETURN_TYPE bpow(int base, int n)
{
 int i,p;
 p = 1;
 for (i = 1; i <= n; i++)
      p = p * base;
 return p;
}       

